Name:           nx
Version:        2.1.0
Release:        1%{?dist}
Summary:        Proxy system for X11

Group:          Applications/Internet
License:        GPL, MIT/X11 for X11 bits
URL:            http://www.nomachine.com
Source0:	nxproxy-%{version}-2.tar.gz
Source1:	nxcomp-%{version}-3.tar.gz
Source2:	nxcompext-%{version}-3.tar.gz
Source3:	nx-X11-%{version}-2.tar.gz
Source4:	nxagent-%{version}-9.tar.gz
Source5:	nxviewer-%{version}-4.tar.gz
Source6:	nxdesktop-%{version}-3.tar.gz
Source7:	nxscripts-%{version}-1.tar.gz
Source8:	nxssh-%{version}-1.tar.gz
Source9:	nxagent
Source10:	docs.tar.bz2
Source11:	nxfind-provides.sh
Patch0:		NX.diff
Patch1:		NX-noansi.diff
Patch2:		p_XFree86-4.3-ppc64.diff
Patch5:		NX-bufferoverflow.diff
Patch6:		NX-data-range.patch
Patch7:		ppc-no-signed-char.diff

%define _use_internal_dependency_generator 0
%define __find_provides %{SOURCE11}

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  expat-devel audiofile-devel openssl-devel libjpeg-devel libpng-devel libX11-devel libXp-devel imake
Requires:	xorg-x11-server-Xorg xorg-x11-apps xorg-x11-utils
Requires(post): policycoreutils
Requires(postun): policycoreutils
Excludearch:	x86_64

%description
NX provides a proxy system for the X Window System.

%prep
%setup -q -T -c %{name}-%{version} -a0 -a1 -a2 -a3 -a4 -a5 -a6 -a7 -a8
%patch0 -p0
pushd nx-X11
%patch1 -p0
%patch2 -p1
popd
%patch5 -p0
%patch6 -p1
%patch7 -p0
ln -s rdesktop.1 nxdesktop/doc/nxdesktop.1
cat >> nx-X11/config/cf/host.def << EOF
#ifdef  i386Architecture
#undef  DefaultGcc2i386Opt
#define DefaultGcc2i386Opt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  MipsArchitecture
#undef  DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef s390xArchitecture
#undef OptimizedCDebugFlags
#define OptimizedCDebugFlags $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
EOF

%build
export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"
perl -pi -e"s|CXXFLAGS=.-O.*|CXXFLAGS=\"$CXXFLAGS\"|" */configure
# build Compression Library and Proxy
for i in nxcomp nxproxy; do
  pushd $i; ./configure; make; popd
done
# build X11 Support Libraries and Agents
pushd nx-X11
  make World
popd
# build Extended Compression Library
pushd nxcompext
  ./configure; make
popd
# build nxssh
pushd nxssh
  ./configure; make
popd
# build RFB Agent
pushd nxviewer
  xmkmf -a
  cp -a %{_libdir}/libXp.so* ../nx-X11/exports/lib/
  make 2> /dev/null
popd
# build RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  ./configure --prefix=%{_prefix} --sharedir=%{_datadir}/NX
  make
popd
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_bindir}
mkdir -p %{buildroot}/%{_libdir}/NX/lib
mkdir -p %{buildroot}/%{_mandir}/man1
# install X11 Support Libraries and Agents
cp -a nx-X11/lib/X11/libX11.so.* \
      nx-X11/lib/Xext/libXext.so.* \
      nx-X11/lib/Xrender/libXrender.so.* \
      %{buildroot}/%{_libdir}/NX/lib
install -m 755 nx-X11/programs/Xserver/nxagent \
  %{buildroot}/%{_libdir}/NX
install -m 755 %{SOURCE9} %{buildroot}/%{_bindir}
# install Compression Libraries and Proxy
cp -a nxcomp/libXcomp.so.* %{buildroot}/%{_libdir}/NX/lib
cp -a nxcompext/libXcompext.so.* %{buildroot}/%{_libdir}/NX/lib
install -m 755 nxproxy/nxproxy %{buildroot}/%{_libdir}/NX
ln -snf nxagent %{buildroot}/%{_bindir}/nxproxy
# install nxssh
pushd nxssh
  cp -a nxssh %{buildroot}/%{_libdir}/NX
  ln -snf nxagent %{buildroot}/%{_bindir}/nxssh
  chmod 755 %{buildroot}/%{_bindir}/nxssh
popd
# install RFB Agent
pushd nxviewer
  make install DESTDIR=%{buildroot}
  mv %{buildroot}/%{_bindir}/nxviewer %{buildroot}/%{_libdir}/NX
  ln -snf nxagent %{buildroot}/%{_bindir}/nxviewer
  chmod 755 %{buildroot}/%{_bindir}/nxviewer
popd
# install RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  make install DESTDIR=%{buildroot}
  mv %{buildroot}/%{_bindir}/nxdesktop %{buildroot}/%{_libdir}/NX
  ln -snf nxagent %{buildroot}/%{_bindir}/nxdesktop
  chmod 755 %{buildroot}/%{_bindir}/nxdesktop
  mv %{buildroot}/usr/man/man1/nxdesktop.1 \
     %{buildroot}/%{_mandir}/man1/nxdesktop.1
  rm -rf %{buildroot}/usr/man
popd
%endif
# install scripts
mkdir -p %{buildroot}/%{_datadir}/doc/%{name}-%{version}
cp -r nxscripts %{buildroot}/%{_datadir}/doc/%{name}-%{version}
# documentation and license
tar xjf %{SOURCE10} -C %{buildroot}/%{_datadir}/doc/%{name}-%{version}
install -m 644 nxcomp/LICENSE   %{buildroot}/%{_datadir}/doc/%{name}-%{version}
for i in nxcomp nxdesktop; do
  mkdir %{buildroot}/%{_datadir}/doc/%{name}-%{version}/$i
done
install -m 644 nxcomp/README    %{buildroot}/%{_datadir}/doc/%{name}-%{version}/nxcomp
install -m 644 nxdesktop/README %{buildroot}/%{_datadir}/doc/%{name}-%{version}/nxdesktop
rm -rf nxdesktop/doc/CVS
cp -r nxdesktop/doc %{buildroot}/%{_datadir}/doc/%{name}-%{version}/nxdesktop

%post
%{_sbindir}/semanage fcontext -f -- -a -t textrel_shlib_t '%{_libdir}/NX/lib/libXcomp.so.%{version}' 2>/dev/null || :
%{_sbindir}/semanage fcontext -f -- -a -t textrel_shlib_t '%{_libdir}/NX/lib/libXcompext.so.%{version}' 2>/dev/null || :
%{_bindir}/chcon -t textrel_shlib_t %{_libdir}/NX/lib/libXcomp.so.%{version} 2>/dev/null || :
%{_bindir}/chcon -t textrel_shlib_t %{_libdir}/NX/lib/libXcompext.so.%{version} 2>/dev/null || :

%postun
if [ $1 -eq 0 ]; then
  %{_sbindir}/semanage fcontext -f -- -d -t textrel_shlib_t '%{_libdir}/NX/lib/libXcomp.so.%{version}' 2>/dev/null || :
  %{_sbindir}/semanage fcontext -f -- -d -t textrel_shlib_t '%{_libdir}/NX/lib/libXcompext.so.%{version}' 2>/dev/null || :
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc %{_datadir}/doc/%{name}-%{version}
%{_bindir}/*
%dir %{_libdir}/NX
%{_libdir}/NX/*
%ifnarch ppc ppc64 s390 s390x
%dir %{_datadir}/NX
%{_mandir}/man1/nxdesktop.1.gz
%{_datadir}/NX/keymaps-windows/
%endif

%changelog
* Thu Sep 28 2006 Rick Stout <zipsonic[AT]gmail.com> - 2.1.0-1
- updated to 2.1.0 release
* Mon Aug 28 2006 Rick Stout <zipsonic[AT]gmail.com> - 2.0.0-4
- upped release for rebuild request
- removed link in post for /usr/X11R6/lib/X11 as it is now
  handled in freenx
- updated to maintenance release 2
- added nxssh component for future qtnx client
* Thu Jul 13 2006 Rick Stout <zipsonic[AT]gmail.com> - 2.0.0-3
- updated to 2.0.0 Maintenance release 1
* Tue Jul 11 2006 Rick Stout <zipsonic[AT]gmail.com> - 2.0.0-1
- upgraded to 2.0.0
- removed renderextension patch as it is unnecessary
- cleaned up spec file
* Tue Jun 13 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-11
- fixed documentation directory problems BZ#194964
* Sat Jun 10 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-10
- added Source11 to filter find-provides from showing libraries that should not
  be provided to the system. BZ#194652
* Wed Jun 07 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-9
- added Dist tag
- fixed macro/variable inconsistencies
- added requires: post and postun for policycoreutils
* Tue Jun 06 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-8
- adapting spec for fedora-extras
- excluding x86_64 arch at this time. nxagent causes segfaults
* Mon May 08 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-7.FC5
- added a section to %post that links /usr/X11R6/lib/X11 to /usr/share/X11
  which is needed for nxagent to function properly
* Sun May 07 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-6.FC5
- added support for selinux
* Tue May 02 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-5.FC5
- reenabled nxviewer
* Mon May 01 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-4.FC5.2
- rebuilt for FC5
- nxviewer still disabled
* Mon Jan 30 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-4.FC5
- disabled the nxviewer build because it doesn't like modular X
- updated xorg dependencies
* Tue Dec 13 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-4
- updated perl script line 76 to have quotes
* Tue Dec 13 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-3
- updated all components to most recent release - Maintenance 3
- removed NX-1.5.diff
* Wed Aug 31 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-2
- updated nxagent to ver .90
- added patches from SuSE to update some compiler warnings and buffer overflows
* Fri Aug 12 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-1
- updated nxcomp to ver .65
* Tue Jul 26 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-0
- Updated to 1.5.0 final
* Mon Jul 11 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.4.9.4-0
- Updated to 1.5.0 snapshot 4
* Thu Jun 30 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.4.9.3-0
- reworked package for update to 1.5.0 devel snapshot 3 (1.4.9.3)
- Commented out Xtranssock patch in NX.diff (doesn't seem to be necessary)
* Mon Apr 11 2005 Tom "spot" Callaway <tcallawa@redhat.com> - 1.4.0-5
- spec cleanups
- reworked Patch1 to make it apply without arch conditional
* Mon Feb 14 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-4
- updated nx-X11, nxproxy, nxcomp, nxagent and nxdesktop
- released to address X11 security concerns.
* Tue Nov 09 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-3
- updated to 1.4.0 final
* Mon Oct 11 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-2
- Changed naming structure to be more friendly (lowercase)
* Fri Oct 07 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-1
- Updated package dependencies
* Wed Sep 29 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-0
- Initial Fedora RPM release.
- Updated SuSE package to work with Fedora
